package org.jboss.testsample.rest;
import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;

import org.jboss.testsample.model.Member;


/**
 * JAX-RS Example
 * 
 * This class produces a RESTful service to read the contents of the members table.
 */
@Path("/members")
public interface MemberService {
	@GET
	@Produces("application/json")
	public List<Member> listAllMembers();

	@GET
	@Path("/{id:[0-9][0-9]*}")
	@Produces("application/json")
	public Member lookupMemberById(@PathParam("id") long id);
}
